﻿Imports SldWorks
Imports SwConst
Imports System.IO
Imports Microsoft.Win32


Module Allgemeine_Einstellungen

    'Public Const c_PDMID As String = "SAPName"
    Public Const c_Bezeichnung_01 As String = "CADtitle2_home_language"
    Public Const c_Bezeichnung_02 As String = "CADtitle1_home_language"
    Public Const c_Konstrukteur As String = "Name"
    Public Const c_Oberflächenbehandlung As String = "Oberflächenbehandlung"
    Public Const c_Version As String = "SAPVersion"
    Public Const c_Freigabeam As String = "Datum"
    Public Const c_Gewicht As String = "Gewicht"
    Public Const c_Material As String = "Werkstoff"
    'Public Const c_Kaufteilpfad As String = "F:\Firma Daten\Externe Firmen\Weber GmbH\Konstruktions Bibliothek\Kaufteile\"


    Dim swapp, part As Object
    Dim boolstatus As Boolean
    Public Sub Einstellungenänder()
        swapp = CreateObject("SldWorks.Application")
        part = swapp.activeDoc

        boolstatus = swapp.SetUserPreferenceIntegerValue(swUserPreferenceIntegerValue_e.swResolveLightweight, 1)
        boolstatus = swapp.SetUserPreferenceIntegerValue(swUserPreferenceIntegerValue_e.swPerformanceAssemRebuildOnLoad, swPromptAlwaysNever_e.swResponseAlways)
        boolstatus = swapp.SetUserPreferenceIntegerValue(swUserPreferenceIntegerValue_e.swCheckForOutOfDateLightweightComponents, 2)
        swapp.SetUserPreferenceToggle(swUserPreferenceToggle_e.swAutoLoadPartsLightweight, False)
        swapp.SetUserPreferenceToggle(swUserPreferenceToggle_e.swPerformanceAlwaysResolveSubassemblies, True)
        swapp.SetUserPreferenceToggle(swUserPreferenceToggle_e.swLargeAsmModeEnabled, False)
        swapp.SetUserPreferenceToggle(swUserPreferenceToggle_e.swSaveNewComponentsToExternalFile, True)

    End Sub
    Public Sub Einstellungenauslesen()

        Dim regkey As RegistryKey
        swapp = CreateObject("SldWorks.Application")
        part = swapp.activeDoc

        regkey = Registry.CurrentUser.CreateSubKey("Software\TZSoftware\")
        regkey.SetValue("SWALPL", swapp.GetUserPreferenceToggle(swUserPreferenceToggle_e.swAutoLoadPartsLightweight))
        regkey.SetValue("SWPARS", swapp.GetUserPreferenceToggle(swUserPreferenceToggle_e.swPerformanceAlwaysResolveSubassemblies))
        regkey.SetValue("SWLAME", swapp.GetUserPreferenceToggle(swUserPreferenceToggle_e.swLargeAsmModeEnabled))
        regkey.SetValue("SWSNCTEF", swapp.GetUserPreferenceToggle(swUserPreferenceToggle_e.swSaveNewComponentsToExternalFile))
        regkey.SetValue("SWRL", swapp.GetUserPreferenceIntegerValue(swUserPreferenceIntegerValue_e.swResolveLightweight))
        regkey.SetValue("SWPAROL", swapp.GetUserPreferenceIntegerValue(swUserPreferenceIntegerValue_e.swPerformanceAssemRebuildOnLoad))
        regkey.SetValue("SWCFODLC", swapp.GetUserPreferenceIntegerValue(swUserPreferenceIntegerValue_e.swCheckForOutOfDateLightweightComponents))

    End Sub
    Public Sub Einstellungzurücksetzen()
        Dim regkey As RegistryKey

        regkey = Registry.CurrentUser.CreateSubKey("Software\TZSoftware\")

        boolstatus = swapp.SetUserPreferenceIntegerValue(swUserPreferenceIntegerValue_e.swResolveLightweight, regkey.GetValue("SWRL"))
        boolstatus = swapp.SetUserPreferenceIntegerValue(swUserPreferenceIntegerValue_e.swPerformanceAssemRebuildOnLoad, regkey.GetValue("SWPAROL"))
        boolstatus = swapp.SetUserPreferenceIntegerValue(swUserPreferenceIntegerValue_e.swCheckForOutOfDateLightweightComponents, regkey.GetValue("SWCFODLC"))
        swapp.SetUserPreferenceToggle(swUserPreferenceToggle_e.swAutoLoadPartsLightweight, regkey.GetValue("SWALPL"))
        swapp.SetUserPreferenceToggle(swUserPreferenceToggle_e.swPerformanceAlwaysResolveSubassemblies, regkey.GetValue("SWPARS"))
        swapp.SetUserPreferenceToggle(swUserPreferenceToggle_e.swLargeAsmModeEnabled, regkey.GetValue("SWLAME"))
        swapp.SetUserPreferenceToggle(swUserPreferenceToggle_e.swSaveNewComponentsToExternalFile, regkey.GetValue("SWSNCTEF"))

    End Sub
End Module

