﻿Option Explicit On

Imports SldWorks
Imports SwConst
Imports System.IO
Public Class _BG_Struktur
    Public zähler As Integer
    Public positionsnr As Integer
    Private _Datafile As New FileInfo("AQUADat.xml")
    Public Sub addartnr(ByVal component As Object, ByVal swmodel As SldWorks.ModelDoc2, ByVal Tn As TreeNode)

        Dim swModelDocExt As ModelDocExtension
        Dim swCustProp As CustomPropertyManager
        Dim gefunden As Boolean = False
        Dim gefunden2 As Boolean = False
        Dim val As String = Nothing
        Dim valout As String = Nothing
        Dim swtype As Integer
        Dim foundrow() As DataRow

        If Not component Is Nothing Then
            If component.issuppressed = True Or component.ExcludeFromBOM = True Then
                Exit Sub
            Else
                swmodel = component.getmodeldoc
            End If
        End If


        swModelDocExt = swmodel.Extension
        swCustProp = swModelDocExt.CustomPropertyManager("")
        gefunden2 = swCustProp.Get4(Form1.c_PDMID, False, val, valout)

        Tn.Text = valout


        If valout = "" Then
            gefunden = False
        Else
            foundrow = Form1._BG_Struktur.Artikel.Select("PDMID = '" & valout & "'")
            For Each row As DataRow In foundrow
                If row("PDMID") = CInt(valout) Then
                    gefunden = True
                End If
            Next

        End If

        If gefunden = False Then


            swtype = swmodel.GetType
            Dim artnewrow As DataRow = Form1._BG_Struktur.Artikel.NewRow
            artnewrow.BeginEdit()
            gefunden = swCustProp.Get4(Form1.c_PDMID, False, val, valout)
            If valout = "" Then
                zähler = zähler + 1
                artnewrow("PDMID") = zähler
            Else
                artnewrow("PDMID") = CInt(valout)
            End If
            artnewrow("Dateipfad") = swmodel.GetPathName
            gefunden = swCustProp.Get4(c_Bezeichnung_01, False, val, valout)
            artnewrow("Bezeichnung_01") = valout
            gefunden = swCustProp.Get4(c_Bezeichnung_02, False, val, valout)
            artnewrow("Bezeichnung_02") = valout
            gefunden = swCustProp.Get4(c_Konstrukteur, False, val, valout)
            artnewrow("Konstrukteur") = valout
            gefunden = swCustProp.Get4(c_Gewicht, False, val, valout)
            artnewrow("Gewicht") = 0.0
            gefunden = swCustProp.Get4(c_Material, False, val, valout)
            artnewrow("Material") = valout
            gefunden = swCustProp.Get4("Number", False, val, valout)
            artnewrow("Oberflächenbehandlung") = valout
            gefunden = swCustProp.Get4("Number", False, val, valout)
            artnewrow("Version") = valout
            gefunden = swCustProp.Get4(c_Freigabeam, False, val, valout)
            If valout = "" Then
                artnewrow("Freigabeam") = CDate("01.01.1900")
            Else
                artnewrow("Freigabeam") = CDate(valout)
            End If
            artnewrow("Kaufteil") = kaufteil(artnewrow("Dateipfad"))
            If artnewrow("Kaufteil") = True Then
                artnewrow("Hauptkategorie") = addhauprkategorie(artnewrow("Dateipfad"))
                artnewrow("Unterkategorie") = addUnterkategorie(artnewrow("Dateipfad"))
                artnewrow("Zeichnung") = False
            Else
                artnewrow("Zeichnung") = True
            End If

            artnewrow("Konstruktive_BG") = False
            artnewrow("Dateityp") = "sldprt"
            If swtype = 2 Then
                If swmodel.ConfigurationManager.ActiveConfiguration.ShowChildComponentsInBOM = False Then
                    Tn.BackColor = Color.Green
                    artnewrow("Konstruktive_BG") = False
                    artnewrow("Dateityp") = "sldasm"
                    If artnewrow("Kaufteil") = False Then
                        addnewBOM(CStr(artnewrow("PDMID")))
                    End If
                ElseIf swmodel.ConfigurationManager.ActiveConfiguration.ShowChildComponentsInBOM = True Then
                    Tn.BackColor = Color.Goldenrod
                    artnewrow("Zeichnung") = False
                    artnewrow("Konstruktive_BG") = True
                    artnewrow("Dateityp") = "sldasm"
                End If
            End If
            artnewrow.EndEdit()
            Form1._BG_Struktur.Artikel.Rows.Add(artnewrow)
        ElseIf gefunden = True Then
            swtype = swmodel.GetType
            If swtype = 2 Then
                If swmodel.ConfigurationManager.ActiveConfiguration.ShowChildComponentsInBOM = False Then
                    Tn.BackColor = Color.Green
                ElseIf swmodel.ConfigurationManager.ActiveConfiguration.ShowChildComponentsInBOM = True Then
                    Tn.BackColor = Color.Goldenrod
                End If
            End If
        End If
    End Sub
    Public Sub fillbom(ByVal component As Object, ByVal swmodel As SldWorks.ModelDoc2, ByVal stckltable As DataTable)

        Dim swModelDocExt As ModelDocExtension
        Dim swCustProp As CustomPropertyManager
        Dim gefunden As Boolean = False
        Dim gefunden2 As Boolean = False
        Dim val As String = Nothing
        Dim valout As String = Nothing
        Dim swtype As Integer
        Dim foundrow() As DataRow

        If Not component Is Nothing Then
            If component.issuppressed = True Or component.ExcludeFromBOM = True Then
                Exit Sub
            Else
                swmodel = component.getmodeldoc
            End If
        End If


        swModelDocExt = swmodel.Extension
        swCustProp = swModelDocExt.CustomPropertyManager("")
        gefunden2 = swCustProp.Get4(Form1.c_PDMID, False, val, valout)


        If valout = "" Then
            gefunden = False
        Else
            foundrow = stckltable.Select("PDMID = '" & CInt(valout) & "'")
            For Each row As DataRow In foundrow
                If row("PDMID") = CInt(valout) Then
                    gefunden = True
                    row.BeginEdit()
                    row("Stückzahl") = row("Stückzahl") + 1
                    row.EndEdit()
                End If
            Next

        End If

        If gefunden = False Then

            swtype = swmodel.GetType
            Dim artnewrow As DataRow = stckltable.NewRow
            artnewrow.BeginEdit()
            gefunden = swCustProp.Get4(Form1.c_PDMID, False, val, valout)
            positionsnr = positionsnr + 1
            If valout = "" Then
                zähler = zähler + 1
                artnewrow("PDMID") = zähler
                artnewrow("Positions_nr") = positionsnr
                artnewrow("Stückzahl") = 1
            Else
                artnewrow("PDMID") = CInt(valout)
                artnewrow("Positions_nr") = positionsnr
                artnewrow("Stückzahl") = 1
            End If

            artnewrow("Dateipfad") = swmodel.GetPathName
            artnewrow("Bezeichnung_01") = valout
            gefunden = swCustProp.Get4(c_Bezeichnung_02, False, val, valout)
            artnewrow("Bezeichnung_02") = valout
            gefunden = swCustProp.Get4(c_Konstrukteur, False, val, valout)
            artnewrow("Konstrukteur") = valout
            gefunden = swCustProp.Get4(c_Gewicht, False, val, valout)
            artnewrow("Gewicht") = 0.0
            gefunden = swCustProp.Get4(c_Material, False, val, valout)
            artnewrow("Material") = valout
            gefunden = swCustProp.Get4("Number", False, val, valout)
            artnewrow("Oberflächenbehandlung") = valout
            gefunden = swCustProp.Get4("Number", False, val, valout)
            artnewrow("Version") = valout
            gefunden = swCustProp.Get4(c_Freigabeam, False, val, valout)
            If valout = "" Then
                artnewrow("Freigabeam") = CDate("01.01.1900")
            Else
                artnewrow("Freigabeam") = CDate(valout)
            End If
            artnewrow("Kaufteil") = kaufteil(artnewrow("Dateipfad"))
            If artnewrow("Kaufteil") = True Then
                artnewrow("Hauptkategorie") = addhauprkategorie(artnewrow("Dateipfad"))
                artnewrow("Unterkategorie") = addUnterkategorie(artnewrow("Dateipfad"))
                artnewrow("Zeichnung") = False
            Else
                artnewrow("Zeichnung") = True
            End If
            artnewrow("Konstruktive_BG") = False
            artnewrow("Dateityp") = "sldprt"
            If swtype = 2 Then
                artnewrow("Dateityp") = "sldasm"
            End If
            artnewrow.EndEdit()
            stckltable.Rows.Add(artnewrow)
        End If
    End Sub
    Public Sub addnewBOM(ByVal PDMID As String)
        Dim gefunden As Boolean = False
        Dim newtable As DataTable
        Dim newcol As DataColumn
        Dim allbom As DataSet = Form1._BG_Struktur
        For i = 0 To allbom.Tables.Count - 1
            If PDMID = allbom.Tables(i).TableName Then
                gefunden = True
            End If
        Next

        If gefunden = False Then
            newtable = allbom.Tables.Add(PDMID)
            newcol = newtable.Columns.Add("PDMID")
            newcol.AllowDBNull = False
            newtable.Columns.Add("Stückzahl")
            newtable.Columns.Add("Positions_nr")
            newtable.Columns.Add("Bezeichnung_01")
            newtable.Columns.Add("Bezeichnung_02")
            newtable.Columns.Add("Konstrukteur")
            newtable.Columns.Add("DateiTyp")
            newtable.Columns.Add("Hauptkategorie")
            newtable.Columns.Add("Unterkategorie")
            newtable.Columns.Add("Preis")
            newtable.Columns.Add("Gewicht")
            newtable.Columns.Add("Material")
            newtable.Columns.Add("Oberflächenbehandlung")
            newtable.Columns.Add("Version")
            newtable.Columns.Add("Freigabeam")
            newtable.Columns.Add("Konstruktive_BG")
            newtable.Columns.Add("Zeichnung")
            newtable.Columns.Add("Dateipfad")
            newtable.Columns.Add("Kaufteil")
        End If

        Form1.Label5.Text = allbom.Tables.Count

    End Sub
    Public Sub savedataset()
        Form1._BG_Struktur.WriteXml(_Datafile.FullName)
    End Sub
    Private Function kaufteil(ByVal filepath As String) As Boolean
        Dim ergebniss As Boolean = False

        If filepath Like Form1.c_Kaufteilpfad & "*" Then
            ergebniss = True
            Dim kurzpfad As String
            kurzpfad = filepath.Replace(Form1.c_Kaufteilpfad, "")
            addkategorie(filepath)
        End If

        Return ergebniss
    End Function
    Private Sub addkategorie(ByVal filepath As String)
        Dim unterkat As Boolean = False
        Dim kat As Boolean = False
        Dim Typtab As DataTable = Form1._BG_Struktur.Typ

        If filepath Like Form1.c_Kaufteilpfad & "*" Then
            Dim kategorie() As String
            Dim kurzpfad As String
            kurzpfad = filepath.Replace(Form1.c_Kaufteilpfad, "")
            kategorie = kurzpfad.Split("\")
            If Typtab.Rows.Count - 1 < 0 Then
                Typtab.Rows.Add(kategorie(0).ToString, kategorie(1).ToString)
            Else
                Dim foundrows() As DataRow
                Dim searchstring As String = "Hauptkategorie = '" & kategorie(0) & "'"
                Dim gefunden As Boolean = False
                foundrows = Typtab.Select(searchstring)
                For Each row1 As DataRow In foundrows
                    If row1("Unterkategorie") = kategorie(1) Then
                        gefunden = True
                    End If
                Next
                If gefunden = False Then
                    Dim row As DataRow
                    row = Typ.NewRow
                    row.BeginEdit()
                    row("Hauptkategorie") = kategorie(0)
                    row("UnterKategorie") = kategorie(1)
                    row.EndEdit()
                    Typ.Rows.Add(row)
                End If
            End If
        End If
    End Sub
    Public Function addhauprkategorie(ByVal filepath As String) As String

        Dim ergebniss As String
        Dim unterkat As Boolean = False
        Dim kat As Boolean = False
        Dim Typtab As DataTable = Form1._BG_Struktur.Typ

        If filepath Like Form1.c_Kaufteilpfad & "*" Then
            Dim kategorie() As String
            Dim kurzpfad As String
            kurzpfad = filepath.Replace(Form1.c_Kaufteilpfad, "")
            kategorie = kurzpfad.Split("\")
            ergebniss = kategorie(0)
        End If

        Return ergebniss
    End Function
    Public Function addUnterkategorie(ByVal filepath As String) As String

        Dim ergebniss As String
        Dim unterkat As Boolean = False
        Dim kat As Boolean = False
        Dim Typtab As DataTable = Form1._BG_Struktur.Typ

        If filepath Like Form1.c_Kaufteilpfad & "*" Then
            Dim kategorie() As String
            Dim kurzpfad As String
            kurzpfad = filepath.Replace(Form1.c_Kaufteilpfad, "")
            kategorie = kurzpfad.Split("\")
            ergebniss = kategorie(1)
        End If

        Return ergebniss
    End Function
End Class
