﻿Imports SldWorks
Imports SwConst

Imports System.IO

Module Bilder_Rendern

    Dim swApp As SldWorks.SldWorks
    Dim swModel As SldWorks.ModelDoc2
    Dim swRayTraceRenderer As SldWorks.RayTraceRenderer
    Dim swRayTraceRenderOptions As SldWorks.RayTraceRendererOptions
    Dim errors As Long
    Dim warnings As Long
    Dim fileName As String
    Dim status As Boolean
    Dim allbom As DataSet = Form1._BG_Struktur
    Dim arttable As DataTable = Form1._BG_Struktur.Tables("Artikel")
    Public Sub rendermodel(ByVal PDMID As String, ByVal view As String, ByVal viewnr As Integer)

        swApp = CreateObject("SldWorks.Application")
        swModel = swApp.ActiveDoc
        swModel.ShowNamedView2(view, viewnr)
        swModel.ViewZoomtofit2()
        swRayTraceRenderer = swApp.GetRayTraceRenderer(swRayTraceRenderType_e.swPhotoView)
        swRayTraceRenderOptions = swRayTraceRenderer.RayTraceRendererOptions
        swRayTraceRenderOptions.ImageFormat = swRayTraceRenderImageFormat_e.swImageFormat_PNG
        swRayTraceRenderOptions.PreviewRenderQuality = swRayTraceRenderQuality_e.swRenderQuality_Better
        swRayTraceRenderOptions.FinalRenderQuality = swRayTraceRenderQuality_e.swRenderQuality_Maximum
        swRayTraceRenderOptions.BloomEnabled = False
        swRayTraceRenderOptions.BloomThreshold = 70
        swRayTraceRenderOptions.BloomRadius = 4
        swRayTraceRenderOptions.ContourEnabled = True
        swRayTraceRenderOptions.ShadedContour = False
        swRayTraceRenderOptions.ContourLineThickness = 3
        swRayTraceRenderOptions.ContourLineColor = 255
        status = swRayTraceRenderer.RenderToFile(Form1.TextBox4.Text & PDMID & "_0" & CStr(viewnr) & ".png", 800, 600)
        swRayTraceRenderOptions.FinalRenderQuality = swRayTraceRenderQuality_e.swRenderQuality_Maximum

        status = swRayTraceRenderer.CloseRayTraceRender
    End Sub
    Public Sub renderparts()

        For i = 0 To arttable.Rows.Count - 1
            Dim row As DataRow
            row = arttable.Rows(i)
            If row("Konstruktive_BG") = False Then
                Form1.VerbindungSW()
                swApp = CreateObject("SldWorks.Application")
                swModel = swApp.ActiveDoc
                stckl_Enleisen.BGschließen(swModel.GetTitle)
                Select Case CStr(row("DateiTyp"))
                    Case "sldprt"
                        stckl_Enleisen.BGöffnen(row("Dateipfad"), 1)
                    Case "sldasm"
                        stckl_Enleisen.BGöffnen(row("Dateipfad"), 2)
                End Select
                Fensterminimiren()
                rendermodel(CStr(row("PDMID")), "*Vorderseite", 1)
                'rendermodel(CStr(row("PDMID")), "*Rückseite", 2)
                'rendermodel(CStr(row("PDMID")), "*Links", 3)
                rendermodel(CStr(row("PDMID")), "*Rechts", 4)
                'rendermodel(CStr(row("PDMID")), "*Oben", 5)
                'rendermodel(CStr(row("PDMID")), "*Unten", 6)
                rendermodel(CStr(row("PDMID")), "*Isometrisch", 7)

            End If
        Next

    End Sub

End Module
